module Samsung
  module Protocol
    class Response < Frame
      attr_accessor :code, :app_name, :response_frame
      
      def initialize data
        @data = data
        parse_response
      end 

      def response_type
        return :wait if r[0].ord == 0x0a
        return :timeout if r[0].ord == 0x65
        return :accepted if r[0].ord == 0x64 and r[2].ord == 0x01
        return :rejected if r[0].ord == 0x64 and r[2].ord == 0x02
        return :unknown
      end

      private

      def parse_response
        self.code = pop_int8
        self.app_name = pop_string
        self.response_frame = pop_frame
      end

      def r
        response_frame.data
      end

    end
  end
end
